package com.kodcu;

import javax.json.Json;
import javax.json.JsonArray;
import javax.json.JsonArrayBuilder;
import javax.json.JsonReader;
import javax.persistence.AttributeConverter;
import javax.persistence.Converter;
import java.io.StringReader;

/**
 * Created by usta on 06.04.2014.
 */
@Converter(autoApply = true)
public class SkillConverter implements AttributeConverter<JsonArray, String> {

    @Override // Java to DB
    public String convertToDatabaseColumn(JsonArray attribute) {
        if (attribute == null) // null ise boş bir Json dizisi hazırlanır;
            return "[]";
        return attribute.toString(); // null değilse, Json verisi String olarak döndürülür.
    }

    @Override // DB to Java
    public JsonArray convertToEntityAttribute(String dbData) {

        if (dbData == null)
            return Json.createArrayBuilder().build();

        JsonArray jsonArray=null;
        try(StringReader stringReader=new StringReader(dbData);
            JsonReader jsonReader = Json.createReader(stringReader)){
            jsonArray=jsonReader.readArray();
        }

        return jsonArray;
    }
}
